// CheckInvestigator.cpp : implementation file
//

#include "stdafx.h"
#include "cthulhu.h"
#include "CheckInvestigator.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCheckInvestigator dialog


CCheckInvestigator::CCheckInvestigator(CWnd* pParent /*=NULL*/)
	: CDialog(CCheckInvestigator::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCheckInvestigator)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CCheckInvestigator::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCheckInvestigator)
	DDX_Control(pDX, IDC_RESULTS, m_wndResults);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCheckInvestigator, CDialog)
	//{{AFX_MSG_MAP(CCheckInvestigator)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCheckInvestigator message handlers

BOOL CCheckInvestigator::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	
    BOOL fCheckSkills = TRUE;

    //check strings
    if( m_pInvestigator->m_strName.GetLength() == 0 )       m_wndResults.AddString( "The investigator has no name" );
    if( m_pInvestigator->m_strOccupation.GetLength() == 0 ) m_wndResults.AddString( "The investigator has no occupation" );
    if( m_pInvestigator->m_strSex.GetLength() == 0 )        m_wndResults.AddString( "The investigator has no sex..." );

    //check stats
    if( m_pInvestigator->m_nAPP <  0 )                      { m_wndResults.AddString( "The investigator's APP has not been set" ); fCheckSkills = FALSE; }
    if( m_pInvestigator->m_nCON <  0 )                      { m_wndResults.AddString( "The investigator's CON has not been set" ); fCheckSkills = FALSE; }
    if( m_pInvestigator->m_nDEX <  0 )                      { m_wndResults.AddString( "The investigator's DEX has not been set" ); fCheckSkills = FALSE; }
    if( m_pInvestigator->m_nEDU <  0 )                      { m_wndResults.AddString( "The investigator's EDU has not been set" ); fCheckSkills = FALSE; }
    if( m_pInvestigator->m_nINT <  0 )                      { m_wndResults.AddString( "The investigator's INT has not been set" ); fCheckSkills = FALSE; }
    if( m_pInvestigator->m_nPOW <  0 )                      { m_wndResults.AddString( "The investigator's POW has not been set" ); fCheckSkills = FALSE; }
    if( m_pInvestigator->m_nSIZ <  0 )                      { m_wndResults.AddString( "The investigator's SIZ has not been set" ); fCheckSkills = FALSE; }
    if( m_pInvestigator->m_nSTR <  0 )                      { m_wndResults.AddString( "The investigator's STR has not been set" ); fCheckSkills = FALSE; }

    //check other stats
    int nMaxSan = m_pInvestigator->m_nPOW*5;
    if( nMaxSan > 0 )
    {
        //find Cthulhu Mythos skill & shrink SAN if needed
        CInvestigator::InvestigatorSkillList* pCthulhuMythos = m_pInvestigator->FindSkill( "Cthulhu Mythos" );
        if( pCthulhuMythos )
        {
            int n99_CthulhuMythos = (99-pCthulhuMythos->nCurrent);
            if( nMaxSan > n99_CthulhuMythos ) nMaxSan = n99_CthulhuMythos;
        }
    
        if( m_pInvestigator->m_nSAN > nMaxSan )                 { m_wndResults.AddString( "The investigator's SAN is greater than his 99-Cthulhu Mythos value" ); fCheckSkills = FALSE; }
    }


    //check each skill
    if( fCheckSkills )
    {
        CInvestigator::InvestigatorSkillList* pSkills = m_pInvestigator->GetList();

        int nPointsSpent = 0;
        while( pSkills )
        {
            //calculate minimum value
            pSkills->nMinimumValue = m_pInvestigator->GetSkillNumber( pSkills->pSkill->m_strBase );
            if( pSkills->nCurrent < pSkills->nMinimumValue )
            {
                const char* pszName;
                if( pSkills->pSkill->GetType() == SPECIALISESKILLITEM )
                {
                    CString str = ((CSpecialiseSkillSkill*)pSkills->pSkill)->m_pSkill->m_strName;
                    if( pSkills->pSkill->m_strName == "" )
                        str += "(unnamed)";
                    else
                        str += pSkills->pSkill->m_strName;

                    pszName = LPCSTR(str);
                }
                else
                {
                    pszName = LPCSTR(pSkills->pSkill->m_strName);

                    //trim the stars
                    while( *pszName == '*' ) pszName++;

                    CString strError;
                    strError.Format( "\"%s\" has been allocated less than its minimum value (%d%%)", pszName, pSkills->nMinimumValue );
                    m_wndResults.AddString( strError );
                }
            }
            else
            {
                nPointsSpent += (pSkills->nCurrent - pSkills->nMinimumValue);
                if( pSkills->pSkill->GetType() == SPECIALISESKILLITEM )
                {
                    if( ( pSkills->nCurrent > pSkills->nMinimumValue || pSkills->pSkill->IsCalculatedBase() ) && pSkills->pSkill->m_strName.GetLength() == 0 )
                    {
                        const char* pszName = LPCSTR(((CSpecialiseSkillSkill*)pSkills->pSkill)->m_pSkill->m_strName);
                        while( *pszName == '*' ) pszName++;
                        
                        CString strError;
                        strError.Format( "A sub-item of %s has been allocated points but not named", pszName );
                        m_wndResults.AddString( strError );
                    }
                }
            }

            pSkills = pSkills->next;
        }

        int nPointsAvailable = (m_pInvestigator->m_nEDU*20) + (m_pInvestigator->m_nINT*10);
        int nPointsAvailableSchool = ((m_pInvestigator->m_nEDU-1)*20) + ((m_pInvestigator->m_nINT+1)*10);
        if( nPointsSpent > nPointsAvailable )
        {
            CString strError;
            strError.Format( "%d too many skill have been points allocated", nPointsSpent-nPointsAvailable );
            m_wndResults.AddString( strError );
            m_wndResults.AddString( "\t(This is only a guess, however)" );
        }
        else
        {
            if( nPointsSpent < nPointsAvailable )
            {
                CString strError;
                strError.Format( "%d too few skill points allocated (not counting extra schooling year)", nPointsAvailable-nPointsSpent );
                m_wndResults.AddString( strError );
                m_wndResults.AddString( "\t(This is only a guess, however)" );
            }
        }
    }

    if( m_wndResults.GetCount() <= 0 )
    {
        //no errors? close the dialog ASAP!
        AfxMessageBox( "The investigator check is complete", MB_ICONINFORMATION );
        PostMessage( WM_CLOSE );
    }

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
