// Cthulhu.h : main header file for the CTHULHU application
//

#if !defined(AFX_CTHULHU_H__B534ECC5_A26B_11D1_89C0_00001C192944__INCLUDED_)
#define AFX_CTHULHU_H__B534ECC5_A26B_11D1_89C0_00001C192944__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"       // main symbols

extern CString GetDefaultDirectory();

extern int GetValueInRange( int nMin, int nMax, int nMultiplier );

//program control constants
#define MAX_AGE 100
#define MAX_UNDO_SIZE 25

//dice constants
#define D4_MIN (1)
#define D4_MAX (4)
#define D4		D4_MAX

#define D6_MIN (1)
#define D6_MAX (6)
#define D6		D6_MAX

#define D8_MIN (1)
#define D8_MAX (8)
#define D8		D8_MAX

#define D10_MIN (1)
#define D10_MAX (10)
#define D10		D10_MAX

#define D20_MIN (1)
#define D20_MAX (20)
#define D20		D20_MAX

#define D100_MIN (1)
#define D100_MAX (100)
#define D100	 D100_MAX



/////////////////////////////////////////////////////////////////////////////
// CCthulhuApp:
// See Cthulhu.cpp for the implementation of this class
//

class CCthulhuApp : public CWinApp
{
public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	CCthulhuApp();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CCthulhuApp)
	public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	//}}AFX_VIRTUAL

// Implementation

	//{{AFX_MSG(CCthulhuApp)
	afx_msg void OnAppAbout();
	afx_msg void OnFileNew();
	afx_msg void OnToolsOptions();
	afx_msg void OnHelpLegalTrademarks();
	afx_msg void OnHelpTheByakheeProject();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
    CDocument* CreateDocument( CString strName );
    void ShowDocument( CDocument* pDoc, CString strName, CString strFrameName = "" );

    //tip stuff
	void ShowTipAtStartup(void);
	void ShowTipOfTheDay(void);
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CTHULHU_H__B534ECC5_A26B_11D1_89C0_00001C192944__INCLUDED_)
