// CthulhuDoc.h : interface of the CCthulhuDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_CTHULHUDOC_H__B534ECCB_A26B_11D1_89C0_00001C192944__INCLUDED_)
#define AFX_CTHULHUDOC_H__B534ECCB_A26B_11D1_89C0_00001C192944__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000


#include "Skill.h"

class CCthulhuDoc : public CDocument
{
    
    friend class CCthulhuView;

protected: // create from serialization only
	CCthulhuDoc();
	DECLARE_DYNCREATE(CCthulhuDoc)

// Attributes
public:
	CInvestigator m_Investigator;
    void UpdateCalculatedBases();

    BOOL m_fNeedRedrawRecalculation;

    void StoreUndo( CString strDescription );
    void Undo();
    void Redo();
    BOOL IsUndo();
    BOOL IsRedo(); 
    void UpdateUndoRedoMenu();

    //portrait info
    char* m_pBitmap;
    HPALETTE m_hPalPortrait;
    UINT m_uWidth, m_uHeight;

    //era metafile
    HENHMETAFILE m_hEmfEra;

/* (one step at a time!!!)
	//back-of-sheet stuff
	CString m_strResidence;
	CString m_strPersonalDescription;
	CString m_strFamiltyAndFriends;
	CString m_strEpisodesOfInsanity;
	CString m_strWoundsAndInjuries;
	CString m_strMarksAndScars;

	CString m_strInvestigatorHistory;

	CString m_strIncome;
	CString m_strCashOnHand;
	CString m_strPersonalProperty;
	CString m_strRealEstate;

	//these chould be lists...
	CString m_strMythosTomesRead;
	CString m_strAdventuringGearEtc;
	CString m_strArtifacts;
	CString m_strSpells;
	CString m_strEntitiesEncountered;
*/

    //undo/redo stuff
	typedef struct tagUNDOREDOLIST {
		CString  strActionDesc;
        CInvestigator Investigator;

		struct tagUNDOREDOLIST* next;
	} UNDOREDOLIST, *LPUNDOREDOLIST;

	LPUNDOREDOLIST m_pUndoList, m_pRedoList;
	int m_nUndo, m_nRedo;

// Operations
public:
    BOOL ShowMiniWizard();
    BOOL ShowFullWizard();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CCthulhuDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Implementation
public:
	void LoadPortraitFile();
	virtual ~CCthulhuDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	BOOL OnNewCharacterWizard();




// Generated message map functions
protected:
	//{{AFX_MSG(CCthulhuDoc)
	afx_msg void OnFileExportHtml();
	afx_msg void OnEditCharacteristics();
	afx_msg void OnRandomiseCharacteristics();
	afx_msg void OnEditGeneralinformation();
	afx_msg void OnEditPlayerinformation();
	afx_msg void OnPortraitBrowse();
	afx_msg void OnPortraitClear();
	afx_msg void OnEditSkills();
	afx_msg void OnAddWeapon();
	afx_msg void OnClearWeapons();
	afx_msg void OnUpdateClearWeapons(CCmdUI* pCmdUI);
	afx_msg void OnUpdatePortraitClear(CCmdUI* pCmdUI);
	afx_msg void OnAddSkill();
	afx_msg void OnToolsCheckInvestigator();
	afx_msg void OnToolsIncome();
	afx_msg void OnEditHitpointsEdit();
	afx_msg void OnEditHitpointsReset();
	afx_msg void OnEditMagicEdit();
	afx_msg void OnEditMagicReset();
	afx_msg void OnEditSanityEdit();
	afx_msg void OnEditSanityReset();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	void LoadEraPicture();
	void DeleteSkillList();
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CTHULHUDOC_H__B534ECCB_A26B_11D1_89C0_00001C192944__INCLUDED_)
