
#include "stdafx.h"
#include "skill.h"
#include "HTMLExport.h"
#include <fstream.h>

void ExportToHTML( CInvestigator* pInvestigator )
{
    /* prompt the user for the export file name */
    OPENFILENAME ofn;
    char szFilename[MAX_PATH+1];
    LPCTSTR lpstrFileMasks = "HTML Documents\0*.htm;*.html\0All Files (*.*)\0*.*\0\0";

    //set default file name ( "investigator name.html" )
    CString strFilename = pInvestigator->m_strName;
    strFilename += ".html";
    strFilename.MakeLower();
    strcpy( szFilename, LPCSTR(strFilename) );

    //fill the structure
    ofn.lStructSize = sizeof(OPENFILENAME);
    ofn.hwndOwner = AfxGetMainWnd()->m_hWnd;
    ofn.hInstance = NULL;
    ofn.lpstrFilter = lpstrFileMasks;
    ofn.lpstrCustomFilter = NULL;
    ofn.nFilterIndex = 1;
    ofn.lpstrFile = szFilename;
    ofn.nMaxFile = MAX_PATH;
    ofn.lpstrFileTitle = NULL;
    ofn.nMaxFileTitle = 0;
    ofn.lpstrInitialDir = NULL;
    ofn.lpstrTitle = "Export File";
    ofn.Flags = OFN_EXPLORER|OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT|OFN_PATHMUSTEXIST;
    ofn.lpstrDefExt = "html";

    //get export file name
    if( GetSaveFileName( &ofn ) == FALSE ) return;


    /* create export file */

    //remove existing file
    DeleteFile( ofn.lpstrFile );

    //create file
    ofstream html( ofn.lpstrFile, ios::out );

    if( html.is_open() == 0 )
    {
        AfxMessageBox( "Cannot create export file", MB_ICONERROR );
        return;
    }

    //prepare variables
    const char* indent = "    ";

    CInvestigator::InvestigatorSkillList* pCthulhuMythos = pInvestigator->FindSkill( "Cthulhu Mythos" );
    int nCthulhuMythos = pCthulhuMythos ? pCthulhuMythos->nCurrent : 0;
    CString strDamageBonus = GetDBString( pInvestigator->m_nSTR, pInvestigator->m_nSIZ );

    /* export the investigator */
    html << "<html>" << endl;

    html << "<head>" << endl;
    html << "<meta http-equiv=\"Content-Type\" content=\"text/html\">" << endl;
    html << "<meta name=\"GENERATOR\" content=\"Byakhee HTML Export Version 1.0\">" << endl;
    html << "<title>" << pInvestigator->m_strName << "</title>" << endl;
    html << "</head>" << endl << endl;

    html << "<body>" << endl;

    html << "<br><br><hr><br><br>" << endl << endl;

    //name and characteristics boxes
    html << "<table border=\"0\" width=\"100%\" >" << endl;

    //name box
    html << "<tr>" << endl;
    html << indent << "<td valign=\"top\" width=\"50%\" >" << endl;
    html << "<b>Investigator Name: </b>" << pInvestigator->m_strName << "<br>" << endl
         << "<b>Occupation: </b>"        << pInvestigator->m_strOccupation << "<br>" << endl
         << "<b>Colleges, Degrees: </b>" << pInvestigator->m_strColleges << "<br>" << endl
         << "<b>Birthplace: </b>"        << pInvestigator->m_strBirthplace << "<br>" << endl
         << "<b>Mental Disorders: </b>"   << pInvestigator->m_strMentalDisorders << "<br>" << endl
         << "<b>Sex: </b>" << pInvestigator->m_strSex << "&nbsp<b>Age: </b>" << pInvestigator->m_nAge << "<br>" << endl;
    html << indent << "</td>" << endl;

    //characteristics box
    html << indent << "<td valign=\"top\" width=\"50%\">" << endl;
    html << indent << indent << "<table border=\"0\" width=\"100%\">" << endl;
    html << indent << indent << "<tr>" << endl
         << indent << indent << indent << "<td width=\"25%\">" << "STR: " << pInvestigator->m_nSTR <<  "</td>" << endl
         << indent << indent << indent << "<td width=\"25%\">" << "DEX: " << pInvestigator->m_nDEX <<  "</td>" << endl
         << indent << indent << indent << "<td width=\"25%\">" << "INT: " << pInvestigator->m_nINT <<  "</td>" << endl
         << indent << indent << indent << "<td width=\"25%\">" << "Idea: " << (pInvestigator->m_nINT*5) <<  "</td>" << endl
         << indent << indent << "</tr>" << endl;
    html << indent << indent << "<tr>" << endl
         << indent << indent << indent << "<td width=\"25%\">" << "CON: " << pInvestigator->m_nCON <<  "</td>" << endl
         << indent << indent << indent << "<td width=\"25%\">" << "APP: " << pInvestigator->m_nAPP <<  "</td>" << endl
         << indent << indent << indent << "<td width=\"25%\">" << "POW: " << pInvestigator->m_nPOW <<  "</td>" << endl
         << indent << indent << indent << "<td width=\"25%\">" << "Luck: " << (pInvestigator->m_nPOW*5) <<  "</td>" << endl
         << indent << indent << "</tr>" << endl;
    html << indent << indent << "<tr>" << endl
         << indent << indent << indent << "<td width=\"25%\">" << "SIZ: " << pInvestigator->m_nSIZ <<  "</td>" << endl
         << indent << indent << indent << "<td width=\"25%\">" << "SAN: " << (pInvestigator->m_nPOW*5) <<  "</td>" << endl
         << indent << indent << indent << "<td width=\"25%\">" << "EDU: " << pInvestigator->m_nEDU <<  "</td>" << endl
         << indent << indent << indent << "<td width=\"25%\">" << "Know: " << (pInvestigator->m_nEDU*5) <<  "</td>" << endl
         << indent << indent << "</tr>" << endl;
    html << indent << indent << "<tr>" << endl
         << indent << indent << indent << "<td colspan=\"2\" width=\"50%\">99-Cthulhu Mythos: " << (99-nCthulhuMythos) << "</td>" << endl
         << indent << indent << indent << "<td colspan=\"2\" width=\"50%\">Damage Bonus: " << strDamageBonus << "</td>" << endl
         << indent << indent << "</tr>" << endl;
    html << indent << indent << "</table>" << endl;
    html << indent << "</td>" << endl;
    html << "</tr>" << endl;
    html << "</table>" << endl;

    html << endl << "<hr>" << endl << endl;

    //write out skills
    html << "<table border=\"0\" width=\"100%\">" << endl;

    CInvestigator::InvestigatorSkillList* pSkills = pInvestigator->GetList();
    int nCount = 2;
    html << indent << indent << "<tr>" << endl;
    while( pSkills )
    {
        switch( pSkills->pSkill->GetType() )
        {
            case SKILL:
            {
                //wrap for columns
                if( ++nCount % 3 == 0 ) html << indent << indent << "</tr>" << endl << indent << indent << "<tr>" << endl;

                //output leader HTML
                html << indent << indent << indent << "<td width=\"33%\"><font size=\"2\">";
                if( pSkills->nCurrent > pSkills->nMinimumValue ) html << "<b>";

                //output skill
                const char * pszName = LPCSTR(pSkills->pSkill->m_strName);
                while( *pszName == '*' ) pszName++;
                html << pszName << " " << pSkills->nCurrent << "%";

                //output trailing HTML
                if( pSkills->nCurrent > pSkills->nMinimumValue ) html << "</b>";
                html << "</font></td>" << endl;
                break;
            }

            case SPECIALISESKILLITEM:
            {

                const char * pszName = LPCSTR(pSkills->pSkill->m_strName);
                while( *pszName == '*' ) pszName++;
                if( strlen(pszName) > 0 )
                {
                    //wrap for columns
                    if( ++nCount % 3 == 0 ) html << indent << indent << "</tr>" << endl << indent << indent << "<tr>" << endl;

                    //output leader HTML
                    html << indent << indent << indent << "<td width=\"33%\"><font size=\"2\">";
                    if( pSkills->nCurrent > pSkills->nMinimumValue ) html << "<b>";

                    //output skill
                    html << ((CSpecialiseSkillSkill*)pSkills->pSkill)->m_pSkill->m_strName << ": " << pszName << " " << pSkills->nCurrent << "%";

                    //output trailing HTML
                    if( pSkills->nCurrent > pSkills->nMinimumValue ) html << "</b>";
                    html << "</font></td>" << endl;
                }


                break;
            }
        }

        //advance the list
        pSkills = pSkills->next;
    }

    //now do firearms
    pSkills = pInvestigator->GetList();
    while( pSkills )
    {
        switch( pSkills->pSkill->GetType() )
        {
            case FIREARM:
            {
                //wrap for columns
                if( ++nCount % 3 == 0 ) html << indent << indent << "</tr>" << endl << indent << indent << "<tr>" << endl;

                //output leader HTML
                html << indent << indent << indent << "<td width=\"33%\"><font size=\"2\">";
                if( pSkills->nCurrent > pSkills->nMinimumValue ) html << "<b>";

                //output skill
                const char * pszName = LPCSTR(pSkills->pSkill->m_strName);
                while( *pszName == '*' ) pszName++;
                html << pszName << " " << pSkills->nCurrent << "%";

                //output trailing HTML
                if( pSkills->nCurrent > pSkills->nMinimumValue ) html << "</b>";
                html << "</font></td>" << endl;
                break;
            }
        }

        //advance the list
        pSkills = pSkills->next;
    }

    //now do melee weapons
    pSkills = pInvestigator->GetList();
    while( pSkills )
    {
        switch( pSkills->pSkill->GetType() )
        {
            case MELEE:
            {
                //wrap for columns
                if( ++nCount % 3 == 0 ) html << indent << indent << "</tr>" << endl << indent << indent << "<tr>" << endl;

                //output leader HTML
                html << indent << indent << indent << "<td width=\"33%\"><font size=\"2\">";
                if( pSkills->nCurrent > pSkills->nMinimumValue ) html << "<b>";

                //output skill
                const char * pszName = LPCSTR(pSkills->pSkill->m_strName);
                while( *pszName == '*' ) pszName++;
                html << pszName << " " << pSkills->nCurrent << "%";

                //output trailing HTML
                if( pSkills->nCurrent > pSkills->nMinimumValue ) html << "</b>";
                html << "</font></td>" << endl;
                break;
            }
        }

        //advance the list
        pSkills = pSkills->next;
    }

    html << indent << indent << "</tr>" << endl;
    html << indent << "</table>" << endl;

    //end of HTML
    html << "<br><br><hr><br><br>" << endl << endl;
    html << "<font size=\"1\">Call of Cthulhu is a registered trademark of Chaosium Inc.</font>" << endl;
    html << endl << "</body>" << endl << "</html>" << endl;


    /* close file */
    html.close();
}
