// NameEtcDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Cthulhu.h"
#include "Skill.h"
#include "NameEtcDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CNameEtcDlg dialog


CNameEtcDlg::CNameEtcDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CNameEtcDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CNameEtcDlg)
	m_nAge = 0;
	m_strBirthplace = _T("");
	m_strColleges = _T("");
	m_strMentalDisorders = _T("");
	m_strName = _T("");
	m_strOccupation = _T("");
	m_strSex = _T("");
	//}}AFX_DATA_INIT
}


void CNameEtcDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CNameEtcDlg)
	DDX_Control(pDX, IDC_MENTALDISORDERS, m_wndMentalDisorders);
	DDX_Control(pDX, IDC_BIRTHPLACE, m_wndBirthplace);
	DDX_Control(pDX, IDC_RANDOMNAME, m_wndRandom);
	DDX_Text(pDX, IDC_AGE, m_nAge);
	DDV_MinMaxInt(pDX, m_nAge, 0, 1000);
	DDX_Text(pDX, IDC_BIRTHPLACE, m_strBirthplace);
	DDX_Text(pDX, IDC_COLLEGES, m_strColleges);
	DDX_Text(pDX, IDC_MENTALDISORDERS, m_strMentalDisorders);
	DDX_Text(pDX, IDC_NAME, m_strName);
	DDX_Text(pDX, IDC_OCCUPATION, m_strOccupation);
	DDX_Text(pDX, IDC_SEX, m_strSex);
	DDV_MaxChars(pDX, m_strSex, 1);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CNameEtcDlg, CDialog)
	//{{AFX_MSG_MAP(CNameEtcDlg)
	ON_BN_CLICKED(IDC_RANDOMNAME, OnRandomName)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNameEtcDlg message handlers

BOOL CNameEtcDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
    //don't display a negative age
    if( m_nAge == -1 ) 
    {
        m_nAge = 0;
        UpdateData(FALSE);
    }

    //set the button's image
	m_wndRandom.SendMessage( BM_SETIMAGE, IMAGE_ICON, (LPARAM)LoadImage( AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_RANDOM), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR ) );
	
    //load in some default options into the birthplace list box
    CString* pstrOptions = GetOptions( "Birthplace" );
	if( pstrOptions != NULL )
	{
		int i = 0;
		while( pstrOptions[i].GetLength() > 0 )
		{
			m_wndBirthplace.AddString( pstrOptions[i] );
			i++;
		}

        delete[] pstrOptions;
	}

    //load in some default options into the phobias list box
    pstrOptions = GetOptions( "Phobias" );
	if( pstrOptions != NULL )
	{
		int i = 0;
		while( pstrOptions[i].GetLength() > 0 )
		{
			m_wndMentalDisorders.AddString( pstrOptions[i] );
			i++;
		}

        delete[] pstrOptions;
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CNameEtcDlg::OnRandomName() 
{
	UpdateData();
    GetRandomName( m_strName, m_strSex );
	UpdateData( FALSE );
}
