// NewCharacter_Pages.h : header file
//

#ifndef __NEWCHARACTER5F_PAGES_H__
#define __NEWCHARACTER5F_PAGES_H__

#include "Skill.h"
#include "ListBoxChildEdit.h"

/////////////////////////////////////////////////////////////////////////////
// CNewCharacter_Outline dialog

class CNewCharacter_Outline : public CPropertyPage
{
	DECLARE_DYNCREATE(CNewCharacter_Outline)

// Construction
public:
	BOOL m_fHadMoreSchooling;
	BOOL m_fSchoolingWorked;
	BOOL m_fRotted;
	int m_nSkillPoints;
	int m_nPersonalInterestPoints;
	CNewCharacter_Outline();
	~CNewCharacter_Outline();

// Dialog Data
	//{{AFX_DATA(CNewCharacter_Outline)
	enum { IDD = IDD_NEWCHAR_OUTLINE };
	CEdit	m_wndAge;
	CSpinButtonCtrl	m_wndAgeSpin;
	CEdit	m_wndEditStr;
	CEdit	m_wndEditSiz;
	CEdit	m_wndEditPow;
	CEdit	m_wndEditInt;
	CEdit	m_wndEditEdu;
	CEdit	m_wndEditDex;
	CEdit	m_wndEditCon;
	CEdit	m_wndEditApp;
	int		m_nAPP;
	int		m_nCON;
	int		m_nDEX;
	int		m_nEDU;
	int		m_nINT;
	int		m_nPOW;
	int		m_nSIZ;
	int		m_nSTR;
	CString	m_strDB;
	CString	m_strHP;
	CString	m_strIdea;
	CString	m_strKnow;
	CString	m_strLuck;
	CString	m_strSAN;
	int		m_nAge;
	CString	m_strPersonalInterest;
	CString	m_strSkillPoints;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CNewCharacter_Outline)
	public:
	virtual BOOL OnSetActive();
	virtual LRESULT OnWizardNext();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CNewCharacter_Outline)
	afx_msg void OnReroll();
	afx_msg void OnKillfocusAge();
	afx_msg void OnDeltaPosAgeSpin(NMHDR* pNMHDR, LRESULT* pResult);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	BOOL m_fFinishedThis;
	void GenerateNewStats();
	void UpdateOtherValues();

	int m_nBaseEDU;
};


/////////////////////////////////////////////////////////////////////////////
// CNewCharacter_Occupation dialog

class CNewCharacter_Occupation : public CPropertyPage
{
	DECLARE_DYNCREATE(CNewCharacter_Occupation)

// Construction
public:
	CNewCharacter_Occupation();
	~CNewCharacter_Occupation();

// Dialog Data
	//{{AFX_DATA(CNewCharacter_Occupation)
	enum { IDD = IDD_NEWCHAR_OCCUPATION };
	CComboBox	m_wndOccupation;
	int		m_iOccupation;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CNewCharacter_Occupation)
	public:
	virtual BOOL OnSetActive();
	virtual LRESULT OnWizardNext();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CNewCharacter_Occupation)
		// NOTE: the ClassWizard will add member functions here
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};


/////////////////////////////////////////////////////////////////////////////
// CNewCharacter_PersonalInterest dialog

class CNewCharacter_PersonalInterest : public CPropertyPage
{
	DECLARE_DYNCREATE(CNewCharacter_PersonalInterest)

// Construction
public:
	int m_nPersonalInterestPoints;
	CNewCharacter_PersonalInterest();
	~CNewCharacter_PersonalInterest();

// Dialog Data
	//{{AFX_DATA(CNewCharacter_PersonalInterest)
	enum { IDD = IDD_NEWCHAR_PERSONALINTEREST };
	CListBox	m_wndListBox;
	CListBoxChildEdit	m_wndSkillEdit;
	CString	m_strInterestPoints;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CNewCharacter_PersonalInterest)
	public:
	virtual BOOL OnSetActive();
	virtual LRESULT OnWizardNext();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CNewCharacter_PersonalInterest)
	afx_msg void OnDrawItem(int nIDCtl, LPDRAWITEMSTRUCT lpDrawItemStruct);
	afx_msg void OnMeasureItem(int nIDCtl, LPMEASUREITEMSTRUCT lpMeasureItemStruct);
	afx_msg void OnDblclkSkilllist();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};


/////////////////////////////////////////////////////////////////////////////
// CNewCharacter_Weapons dialog

class CNewCharacter_Weapons : public CPropertyPage
{
	DECLARE_DYNCREATE(CNewCharacter_Weapons)

// Construction
public:
	void InitialiseWeaponsList();
	CNewCharacter_Weapons();
	~CNewCharacter_Weapons();

// Dialog Data
	//{{AFX_DATA(CNewCharacter_Weapons)
	enum { IDD = IDD_NEWCHAR_WEAPONS };
	CListBox	m_wndInvestigatorWeapons;
	CListBox	m_wndAvailableWeapons;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CNewCharacter_Weapons)
	public:
	virtual BOOL OnSetActive();
	virtual LRESULT OnWizardNext();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CNewCharacter_Weapons)
	afx_msg void OnAddWeapon();
	afx_msg void OnDblclkAvailableWeaponsList();
	afx_msg void OnDblclkInvestigatorWeaponsList();
	afx_msg void OnRemove();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	struct WEAPONLIST {
        CSkill* pSkill;
		BOOL fOccupational;
		WEAPONLIST* next;
	};

	WEAPONLIST* m_pWeaponList;

};


/////////////////////////////////////////////////////////////////////////////
// CNewCharacter_Skills dialog

class CNewCharacter_Skills : public CPropertyPage
{
	DECLARE_DYNCREATE(CNewCharacter_Skills)

// Construction
public:
	void InitialiseSkillsList();
	CNewCharacter_Skills();
	~CNewCharacter_Skills();

// Dialog Data
	//{{AFX_DATA(CNewCharacter_Skills)
	enum { IDD = IDD_NEWCHAR_SKILLS };
	CListBox	m_wndListBox;
	CListBoxChildEdit	m_wndSkillEdit;
	CString	m_strPoints;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CNewCharacter_Skills)
	public:
	virtual BOOL OnSetActive();
	virtual LRESULT OnWizardNext();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CNewCharacter_Skills)
	afx_msg void OnDrawItem(int nIDCtl, LPDRAWITEMSTRUCT lpDrawItemStruct);
	afx_msg void OnDblclkSkillList();
	afx_msg void OnMeasureItem(int nIDCtl, LPMEASUREITEMSTRUCT lpMeasureItemStruct);
	afx_msg void OnResetSkills();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	int m_nSkillPoints;
};


/////////////////////////////////////////////////////////////////////////////
// CNewCharacter_NameEtc dialog

class CNewCharacter_NameEtc : public CPropertyPage
{
	DECLARE_DYNCREATE(CNewCharacter_NameEtc)

// Construction
public:
	CNewCharacter_NameEtc();
	~CNewCharacter_NameEtc();

// Dialog Data
	//{{AFX_DATA(CNewCharacter_NameEtc)
	enum { IDD = IDD_NEWCHAR_NAME };
	CComboBox	m_wndMentalDisorders;
	CComboBox	m_wndBirthplace;
	CButton	m_wndRandom;
	CString	m_strBirthplace;
	CString	m_strColleges;
	CString	m_strName;
	CString	m_strSex;
	CString	m_strMentalDisorders;
	CString	m_strOccupation;
	CString	m_strPortrait;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CNewCharacter_NameEtc)
	public:
	virtual BOOL OnSetActive();
	virtual LRESULT OnWizardNext();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CNewCharacter_NameEtc)
	afx_msg void OnRandomName();
	afx_msg void OnBrowseForPortrait();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


/////////////////////////////////////////////////////////////////////////////
// CNewCharacter_Finished dialog

class CNewCharacter_Finished : public CPropertyPage
{
	DECLARE_DYNCREATE(CNewCharacter_Finished)

// Construction
public:
	CNewCharacter_Finished();
	~CNewCharacter_Finished();

// Dialog Data
	//{{AFX_DATA(CNewCharacter_Finished)
	enum { IDD = IDD_NEWCHAR_FINISH };
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CNewCharacter_Finished)
	public:
	virtual BOOL OnSetActive();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CNewCharacter_Finished)
		// NOTE: the ClassWizard will add member functions here
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};



#endif // __NEWCHARACTER5F_PAGES_H__
