// OptionalSkillsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Cthulhu.h"
#include "OptionalSkillsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COptionalSkillsDlg dialog


COptionalSkillsDlg::COptionalSkillsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(COptionalSkillsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(COptionalSkillsDlg)
	m_strNumSkills = _T("");
	//}}AFX_DATA_INIT

	m_pInvestigator = NULL;
}


void COptionalSkillsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COptionalSkillsDlg)
	DDX_Control(pDX, IDC_SKILLS, m_wndSkills);
	DDX_Text(pDX, IDC_NUMSKILLS, m_strNumSkills);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(COptionalSkillsDlg, CDialog)
	//{{AFX_MSG_MAP(COptionalSkillsDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COptionalSkillsDlg message handlers

BOOL COptionalSkillsDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
    CSkillList::SkillList* pSkills = m_ChoicesList.GetList();

	while( pSkills )
	{
		int i;
		BOOL fAdd = FALSE;

		//if these are the skills we're looking for
		if( pSkills->pSkill->IsEra( m_pInvestigator->m_era ) && pSkills->pSkill->m_strBase[0] != '*' /*prefix * == read only*/ )
		{
            //trim off the leading *s
            char szBuffer[64];
            const char *pBuf = LPCSTR(pSkills->pSkill->m_strName);
            while( *pBuf == '*' ) pBuf++;
            strcpy( szBuffer, pBuf );
            
            //we can go about our business...
            i = m_wndSkills.AddString( (pSkills->pSkill->GetType() == ANYSKILL) ? "(free choice)" : szBuffer );
			if( i != LB_ERR ) m_wndSkills.SetItemData( i, (DWORD)pSkills );
		}

		//move along... move along...
		pSkills = pSkills->next;
	}

	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void COptionalSkillsDlg::OnOK() 
{
	//make sure that there isn't too many selected
	if( m_wndSkills.GetSelCount() > atoi(m_strNumSkills) )
	{
		CString str;
		str.Format( "Sorry - You can only select up to %s skills for this occupation", m_strNumSkills );
		AfxMessageBox( str, MB_ICONEXCLAMATION );
		return;
	}

	//make sure they've actually selected *something*
	if( m_wndSkills.GetSelCount() == 0 )
	{
		if( AfxMessageBox( "Are you sure you don't want to select any of these skills?", MB_YESNO|MB_ICONQUESTION ) == IDYES )
			CDialog::OnOK();

		return;
	}

	//build up a new skills list
    m_OptionalSkills.ResetList();
	int max = m_wndSkills.GetCount();
	for( int i = 0; i < max; i++ )
	{
		//see if this item is selected
		if( m_wndSkills.GetSel(i) > 0 )
		{
            CSkill* pSkill = ((CSkillList::SkillList*)m_wndSkills.GetItemData(i))->pSkill;
            m_OptionalSkills.AddSkill( pSkill );
		}
	}

	CDialog::OnOK();
}
