// PickSkill.cpp : implementation file
//

#include "stdafx.h"
#include "Cthulhu.h"
#include "PickSkill.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPickSkill dialog


CPickSkill::CPickSkill(CWnd* pParent /*=NULL*/)
	: CDialog(CPickSkill::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPickSkill)
	m_strCustomPrompt = _T("");
	//}}AFX_DATA_INIT

	m_pInvestigator = NULL;
}


void CPickSkill::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPickSkill)
	DDX_Control(pDX, IDC_SKILLLIST, m_wndSkillList);
	DDX_Text(pDX, IDC_CUSTOMPROMPT, m_strCustomPrompt);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPickSkill, CDialog)
	//{{AFX_MSG_MAP(CPickSkill)
	ON_LBN_DBLCLK(IDC_SKILLLIST, OnDblclkSkilllist)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPickSkill message handlers

BOOL CPickSkill::OnInitDialog() 
{
	CDialog::OnInitDialog();

	int nBaseUnits = GetDialogBaseUnits();
	int nTabStops[] = { 11*nBaseUnits };

	m_wndSkillList.SetTabStops( sizeof(nTabStops)/sizeof(int), nTabStops );
	
    CInvestigator::InvestigatorSkillList* pSkills = m_pInvestigator->GetList();
	while( pSkills )
	{
        if( pSkills->pSkill->GetType() != SPECIALISESKILLITEM )
        {
            if( pSkills->fOccupational == FALSE )
		    {
                if( (pSkills->pSkill->m_strBase[0] != '*' /*prefix * == read only*/) )
			    {
                    const char * pszName = LPCSTR(pSkills->pSkill->m_strName);
                    while( *pszName == '*' ) pszName++;
				    CString strText;
				    strText.Format( "%s\t%d%%", pszName, m_pInvestigator->GetSkillNumber( pSkills->pSkill->m_strBase) );
                    int i = m_wndSkillList.AddString( strText );
				    m_wndSkillList.SetItemData( i, (DWORD)pSkills );
			    }
		    }
        }

		//advance
		pSkills = pSkills->next;
	}
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CPickSkill::OnOK() 
{
	int i = m_wndSkillList.GetCurSel();
	if( i != LB_ERR )
	{
        CInvestigator::InvestigatorSkillList* pSkill = (CInvestigator::InvestigatorSkillList*)m_wndSkillList.GetItemData(i);
        pSkill->fOccupational = TRUE;
        pSkill->nCurrent = pSkill->nMinimumValue = m_pInvestigator->GetSkillNumber( pSkill->pSkill->m_strBase );

        //set the occupational flag on all child skills too
        if( pSkill->pSkill->GetType() == SPECIALISESKILL )
        {
            for( CInvestigator::InvestigatorSkillList* pSkillList = m_pInvestigator->GetList(); pSkillList != NULL; pSkillList = pSkillList->next )
            {
                //is this a child skill?
                if( pSkillList->pSkill->GetType() == SPECIALISESKILLITEM )
                {
                    //yup, get a pointer to and and see if it's a child of the skill the user picked
                    CSpecialiseSkillSkill* pSpecialItem = (CSpecialiseSkillSkill*)pSkillList->pSkill;
                    if( pSpecialItem->m_pSkill == pSkill->pSkill )
                    {
                        pSkillList->fOccupational = TRUE;
                        pSkillList->nCurrent = pSkillList->nMinimumValue = m_pInvestigator->GetSkillNumber( pSkillList->pSkill->m_strBase );
                    }
                }
            }
        }
	}
	
	CDialog::OnOK();
}

void CPickSkill::OnDblclkSkilllist() 
{
	OnOK();
}
